// SPDX-License-Identifier: MIT
pragma solidity ^0.8.17;
import "./VerifierLogicAbstract.sol";

contract VerifierLogicPart0 is VerifierLogicAbstract {
    function verifyPartial(
        uint256[] memory pubInputs,
        bytes memory proof,
        bool success,
        bytes32[1033] memory transcript
    ) public view override returns (bool, bytes32[1033] memory) {
        assembly {{
                                let f_p := 0x30644e72e131a029b85045b68181585d97816a916871ca8d3c208c16d87cfd47
                    let f_q := 0x30644e72e131a029b85045b68181585d2833e84879b9709143e1f593f0000001
                    function validate_ec_point(x, y) -> valid {
                        {                            let x_lt_p := lt(x, 0x30644e72e131a029b85045b68181585d97816a916871ca8d3c208c16d87cfd47)                            let y_lt_p := lt(y, 0x30644e72e131a029b85045b68181585d97816a916871ca8d3c208c16d87cfd47)                            valid := and(x_lt_p, y_lt_p)                        }
                        {                            let y_square := mulmod(y, y, 0x30644e72e131a029b85045b68181585d97816a916871ca8d3c208c16d87cfd47)                            let x_square := mulmod(x, x, 0x30644e72e131a029b85045b68181585d97816a916871ca8d3c208c16d87cfd47)                            let x_cube := mulmod(x_square, x, 0x30644e72e131a029b85045b68181585d97816a916871ca8d3c208c16d87cfd47)                            let x_cube_plus_3 := addmod(x_cube, 3, 0x30644e72e131a029b85045b68181585d97816a916871ca8d3c208c16d87cfd47)                            let is_affine := eq(x_cube_plus_3, y_square)                            valid := and(valid, is_affine)                        }
                    }
                    mstore(add(transcript, 0x20), mod(mload(add(pubInputs, 0x20)), f_q))
mstore(add(transcript, 0x40), mod(mload(add(pubInputs, 0x40)), f_q))
mstore(add(transcript, 0x60), mod(mload(add(pubInputs, 0x60)), f_q))
mstore(add(transcript, 0x80), mod(mload(add(pubInputs, 0x80)), f_q))
mstore(add(transcript, 0xa0), mod(mload(add(pubInputs, 0xa0)), f_q))
mstore(add(transcript, 0xc0), mod(mload(add(pubInputs, 0xc0)), f_q))
mstore(add(transcript, 0xe0), mod(mload(add(pubInputs, 0xe0)), f_q))
mstore(add(transcript, 0x100), mod(mload(add(pubInputs, 0x100)), f_q))
mstore(add(transcript, 0x120), mod(mload(add(pubInputs, 0x120)), f_q))
mstore(add(transcript, 0x140), mod(mload(add(pubInputs, 0x140)), f_q))
mstore(add(transcript, 0x160), mod(mload(add(pubInputs, 0x160)), f_q))
mstore(add(transcript, 0x180), mod(mload(add(pubInputs, 0x180)), f_q))
mstore(add(transcript, 0x1a0), mod(mload(add(pubInputs, 0x1a0)), f_q))
mstore(add(transcript, 0x1c0), mod(mload(add(pubInputs, 0x1c0)), f_q))
mstore(add(transcript, 0x1e0), mod(mload(add(pubInputs, 0x1e0)), f_q))
mstore(add(transcript, 0x200), mod(mload(add(pubInputs, 0x200)), f_q))
mstore(add(transcript, 0x220), mod(mload(add(pubInputs, 0x220)), f_q))
mstore(add(transcript, 0x240), mod(mload(add(pubInputs, 0x240)), f_q))
mstore(add(transcript, 0x260), mod(mload(add(pubInputs, 0x260)), f_q))
mstore(add(transcript, 0x280), mod(mload(add(pubInputs, 0x280)), f_q))
mstore(add(transcript, 0x2a0), mod(mload(add(pubInputs, 0x2a0)), f_q))
mstore(add(transcript, 0x2c0), mod(mload(add(pubInputs, 0x2c0)), f_q))
mstore(add(transcript, 0x2e0), mod(mload(add(pubInputs, 0x2e0)), f_q))
mstore(add(transcript, 0x300), mod(mload(add(pubInputs, 0x300)), f_q))
mstore(add(transcript, 0x320), mod(mload(add(pubInputs, 0x320)), f_q))
mstore(add(transcript, 0x340), mod(mload(add(pubInputs, 0x340)), f_q))
mstore(add(transcript, 0x360), mod(mload(add(pubInputs, 0x360)), f_q))
mstore(add(transcript, 0x380), mod(mload(add(pubInputs, 0x380)), f_q))
mstore(add(transcript, 0x3a0), mod(mload(add(pubInputs, 0x3a0)), f_q))
mstore(add(transcript, 0x3c0), mod(mload(add(pubInputs, 0x3c0)), f_q))
mstore(add(transcript, 0x3e0), mod(mload(add(pubInputs, 0x3e0)), f_q))
mstore(add(transcript, 0x400), mod(mload(add(pubInputs, 0x400)), f_q))
mstore(add(transcript, 0x420), mod(mload(add(pubInputs, 0x420)), f_q))
mstore(add(transcript, 0x440), mod(mload(add(pubInputs, 0x440)), f_q))
mstore(add(transcript, 0x460), mod(mload(add(pubInputs, 0x460)), f_q))
mstore(add(transcript, 0x480), mod(mload(add(pubInputs, 0x480)), f_q))
mstore(add(transcript, 0x4a0), mod(mload(add(pubInputs, 0x4a0)), f_q))
mstore(add(transcript, 0x4c0), mod(mload(add(pubInputs, 0x4c0)), f_q))
mstore(add(transcript, 0x4e0), mod(mload(add(pubInputs, 0x4e0)), f_q))
mstore(add(transcript, 0x500), mod(mload(add(pubInputs, 0x500)), f_q))
mstore(add(transcript, 0x520), mod(mload(add(pubInputs, 0x520)), f_q))
mstore(add(transcript, 0x540), mod(mload(add(pubInputs, 0x540)), f_q))
mstore(add(transcript, 0x560), mod(mload(add(pubInputs, 0x560)), f_q))
mstore(add(transcript, 0x580), mod(mload(add(pubInputs, 0x580)), f_q))
mstore(add(transcript, 0x5a0), mod(mload(add(pubInputs, 0x5a0)), f_q))
mstore(add(transcript, 0x5c0), mod(mload(add(pubInputs, 0x5c0)), f_q))
mstore(add(transcript, 0x5e0), mod(mload(add(pubInputs, 0x5e0)), f_q))
mstore(add(transcript, 0x600), mod(mload(add(pubInputs, 0x600)), f_q))
mstore(add(transcript, 0x620), mod(mload(add(pubInputs, 0x620)), f_q))
mstore(add(transcript, 0x640), mod(mload(add(pubInputs, 0x640)), f_q))
mstore(add(transcript, 0x660), mod(mload(add(pubInputs, 0x660)), f_q))
mstore(add(transcript, 0x680), mod(mload(add(pubInputs, 0x680)), f_q))
mstore(add(transcript, 0x6a0), mod(mload(add(pubInputs, 0x6a0)), f_q))
mstore(add(transcript, 0x6c0), mod(mload(add(pubInputs, 0x6c0)), f_q))
mstore(add(transcript, 0x6e0), mod(mload(add(pubInputs, 0x6e0)), f_q))
mstore(add(transcript, 0x700), mod(mload(add(pubInputs, 0x700)), f_q))
mstore(add(transcript, 0x720), mod(mload(add(pubInputs, 0x720)), f_q))
mstore(add(transcript, 0x740), mod(mload(add(pubInputs, 0x740)), f_q))
mstore(add(transcript, 0x760), mod(mload(add(pubInputs, 0x760)), f_q))
mstore(add(transcript, 0x780), mod(mload(add(pubInputs, 0x780)), f_q))
mstore(add(transcript, 0x7a0), mod(mload(add(pubInputs, 0x7a0)), f_q))
mstore(add(transcript, 0x7c0), mod(mload(add(pubInputs, 0x7c0)), f_q))
mstore(add(transcript, 0x7e0), mod(mload(add(pubInputs, 0x7e0)), f_q))
mstore(add(transcript, 0x800), mod(mload(add(pubInputs, 0x800)), f_q))
mstore(add(transcript, 0x820), mod(mload(add(pubInputs, 0x820)), f_q))
mstore(add(transcript, 0x840), mod(mload(add(pubInputs, 0x840)), f_q))
mstore(add(transcript, 0x860), mod(mload(add(pubInputs, 0x860)), f_q))
mstore(add(transcript, 0x880), mod(mload(add(pubInputs, 0x880)), f_q))
mstore(add(transcript, 0x8a0), mod(mload(add(pubInputs, 0x8a0)), f_q))
mstore(add(transcript, 0x8c0), mod(mload(add(pubInputs, 0x8c0)), f_q))
mstore(add(transcript, 0x8e0), mod(mload(add(pubInputs, 0x8e0)), f_q))
mstore(add(transcript, 0x900), mod(mload(add(pubInputs, 0x900)), f_q))
mstore(add(transcript, 0x920), mod(mload(add(pubInputs, 0x920)), f_q))
mstore(add(transcript, 0x940), mod(mload(add(pubInputs, 0x940)), f_q))
mstore(add(transcript, 0x960), mod(mload(add(pubInputs, 0x960)), f_q))
mstore(add(transcript, 0x980), mod(mload(add(pubInputs, 0x980)), f_q))
mstore(add(transcript, 0x9a0), mod(mload(add(pubInputs, 0x9a0)), f_q))
mstore(add(transcript, 0x9c0), mod(mload(add(pubInputs, 0x9c0)), f_q))
mstore(add(transcript, 0x9e0), mod(mload(add(pubInputs, 0x9e0)), f_q))
mstore(add(transcript, 0xa00), mod(mload(add(pubInputs, 0xa00)), f_q))
mstore(add(transcript, 0xa20), mod(mload(add(pubInputs, 0xa20)), f_q))
mstore(add(transcript, 0xa40), mod(mload(add(pubInputs, 0xa40)), f_q))
mstore(add(transcript, 0xa60), mod(mload(add(pubInputs, 0xa60)), f_q))
mstore(add(transcript, 0xa80), mod(mload(add(pubInputs, 0xa80)), f_q))
mstore(add(transcript, 0xaa0), mod(mload(add(pubInputs, 0xaa0)), f_q))
mstore(add(transcript, 0xac0), mod(mload(add(pubInputs, 0xac0)), f_q))
mstore(add(transcript, 0xae0), mod(mload(add(pubInputs, 0xae0)), f_q))
mstore(add(transcript, 0xb00), mod(mload(add(pubInputs, 0xb00)), f_q))
mstore(add(transcript, 0xb20), mod(mload(add(pubInputs, 0xb20)), f_q))
mstore(add(transcript, 0xb40), mod(mload(add(pubInputs, 0xb40)), f_q))
mstore(add(transcript, 0xb60), mod(mload(add(pubInputs, 0xb60)), f_q))
mstore(add(transcript, 0xb80), mod(mload(add(pubInputs, 0xb80)), f_q))
mstore(add(transcript, 0xba0), mod(mload(add(pubInputs, 0xba0)), f_q))
mstore(add(transcript, 0x0), 12673191562557143416738431144348012111409189533819334561502053299624000327926)

        {            let x := mload(add(proof, 0x20))            mstore(add(transcript, 0xbc0), x)            let y := mload(add(proof, 0x40))            mstore(add(transcript, 0xbe0), y)            success := and(validate_ec_point(x, y), success)        }
mstore(add(transcript, 0xc00), keccak256(add(transcript, 0x0), 3072))
{            let hash := mload(add(transcript, 0xc00))            mstore(add(transcript, 0xc20), mod(hash, f_q))            mstore(add(transcript, 0xc40), hash)        }

        {            let x := mload(add(proof, 0x60))            mstore(add(transcript, 0xc60), x)            let y := mload(add(proof, 0x80))            mstore(add(transcript, 0xc80), y)            success := and(validate_ec_point(x, y), success)        }

        {            let x := mload(add(proof, 0xa0))            mstore(add(transcript, 0xca0), x)            let y := mload(add(proof, 0xc0))            mstore(add(transcript, 0xcc0), y)            success := and(validate_ec_point(x, y), success)        }
mstore(add(transcript, 0xce0), keccak256(add(transcript, 0xc40), 160))
{            let hash := mload(add(transcript, 0xce0))            mstore(add(transcript, 0xd00), mod(hash, f_q))            mstore(add(transcript, 0xd20), hash)        }
mstore8(add(transcript, 0xd40), 1)
mstore(add(transcript, 0xd40), keccak256(add(transcript, 0xd20), 33))
{            let hash := mload(add(transcript, 0xd40))            mstore(add(transcript, 0xd60), mod(hash, f_q))            mstore(add(transcript, 0xd80), hash)        }

        {            let x := mload(add(proof, 0xe0))            mstore(add(transcript, 0xda0), x)            let y := mload(add(proof, 0x100))            mstore(add(transcript, 0xdc0), y)            success := and(validate_ec_point(x, y), success)        }

        {            let x := mload(add(proof, 0x120))            mstore(add(transcript, 0xde0), x)            let y := mload(add(proof, 0x140))            mstore(add(transcript, 0xe00), y)            success := and(validate_ec_point(x, y), success)        }

        {            let x := mload(add(proof, 0x160))            mstore(add(transcript, 0xe20), x)            let y := mload(add(proof, 0x180))            mstore(add(transcript, 0xe40), y)            success := and(validate_ec_point(x, y), success)        }
mstore(add(transcript, 0xe60), keccak256(add(transcript, 0xd80), 224))
{            let hash := mload(add(transcript, 0xe60))            mstore(add(transcript, 0xe80), mod(hash, f_q))            mstore(add(transcript, 0xea0), hash)        }

        {            let x := mload(add(proof, 0x1a0))            mstore(add(transcript, 0xec0), x)            let y := mload(add(proof, 0x1c0))            mstore(add(transcript, 0xee0), y)            success := and(validate_ec_point(x, y), success)        }

        {            let x := mload(add(proof, 0x1e0))            mstore(add(transcript, 0xf00), x)            let y := mload(add(proof, 0x200))            mstore(add(transcript, 0xf20), y)            success := and(validate_ec_point(x, y), success)        }

        {            let x := mload(add(proof, 0x220))            mstore(add(transcript, 0xf40), x)            let y := mload(add(proof, 0x240))            mstore(add(transcript, 0xf60), y)            success := and(validate_ec_point(x, y), success)        }

        {            let x := mload(add(proof, 0x260))            mstore(add(transcript, 0xf80), x)            let y := mload(add(proof, 0x280))            mstore(add(transcript, 0xfa0), y)            success := and(validate_ec_point(x, y), success)        }
mstore(add(transcript, 0xfc0), keccak256(add(transcript, 0xea0), 288))
{            let hash := mload(add(transcript, 0xfc0))            mstore(add(transcript, 0xfe0), mod(hash, f_q))            mstore(add(transcript, 0x1000), hash)        }
mstore(add(transcript, 0x1020), mod(mload(add(proof, 0x2a0)), f_q))
mstore(add(transcript, 0x1040), mod(mload(add(proof, 0x2c0)), f_q))
mstore(add(transcript, 0x1060), mod(mload(add(proof, 0x2e0)), f_q))
mstore(add(transcript, 0x1080), mod(mload(add(proof, 0x300)), f_q))
mstore(add(transcript, 0x10a0), mod(mload(add(proof, 0x320)), f_q))
mstore(add(transcript, 0x10c0), mod(mload(add(proof, 0x340)), f_q))
mstore(add(transcript, 0x10e0), mod(mload(add(proof, 0x360)), f_q))
mstore(add(transcript, 0x1100), mod(mload(add(proof, 0x380)), f_q))
mstore(add(transcript, 0x1120), mod(mload(add(proof, 0x3a0)), f_q))
mstore(add(transcript, 0x1140), mod(mload(add(proof, 0x3c0)), f_q))
mstore(add(transcript, 0x1160), mod(mload(add(proof, 0x3e0)), f_q))
mstore(add(transcript, 0x1180), mod(mload(add(proof, 0x400)), f_q))
mstore(add(transcript, 0x11a0), mod(mload(add(proof, 0x420)), f_q))
mstore(add(transcript, 0x11c0), mod(mload(add(proof, 0x440)), f_q))
mstore(add(transcript, 0x11e0), mod(mload(add(proof, 0x460)), f_q))
mstore(add(transcript, 0x1200), mod(mload(add(proof, 0x480)), f_q))
mstore(add(transcript, 0x1220), mod(mload(add(proof, 0x4a0)), f_q))
mstore(add(transcript, 0x1240), mod(mload(add(proof, 0x4c0)), f_q))
mstore(add(transcript, 0x1260), mod(mload(add(proof, 0x4e0)), f_q))
mstore(add(transcript, 0x1280), keccak256(add(transcript, 0x1000), 640))
{            let hash := mload(add(transcript, 0x1280))            mstore(add(transcript, 0x12a0), mod(hash, f_q))            mstore(add(transcript, 0x12c0), hash)        }
mstore8(add(transcript, 0x12e0), 1)
mstore(add(transcript, 0x12e0), keccak256(add(transcript, 0x12c0), 33))
{            let hash := mload(add(transcript, 0x12e0))            mstore(add(transcript, 0x1300), mod(hash, f_q))            mstore(add(transcript, 0x1320), hash)        }

        {            let x := mload(add(proof, 0x500))            mstore(add(transcript, 0x1340), x)            let y := mload(add(proof, 0x520))            mstore(add(transcript, 0x1360), y)            success := and(validate_ec_point(x, y), success)        }
mstore(add(transcript, 0x1380), keccak256(add(transcript, 0x1320), 96))
{            let hash := mload(add(transcript, 0x1380))            mstore(add(transcript, 0x13a0), mod(hash, f_q))            mstore(add(transcript, 0x13c0), hash)        }

        {            let x := mload(add(proof, 0x540))            mstore(add(transcript, 0x13e0), x)            let y := mload(add(proof, 0x560))            mstore(add(transcript, 0x1400), y)            success := and(validate_ec_point(x, y), success)        }
{            let x := mload(add(transcript, 0x20))x := add(x, shl(88, mload(add(transcript, 0x40))))x := add(x, shl(176, mload(add(transcript, 0x60))))mstore(add(transcript, 0x1420), x)let y := mload(add(transcript, 0x80))y := add(y, shl(88, mload(add(transcript, 0xa0))))y := add(y, shl(176, mload(add(transcript, 0xc0))))mstore(add(transcript, 0x1440), y)            success := and(validate_ec_point(x, y), success)        }
{            let x := mload(add(transcript, 0xe0))x := add(x, shl(88, mload(add(transcript, 0x100))))x := add(x, shl(176, mload(add(transcript, 0x120))))mstore(add(transcript, 0x1460), x)let y := mload(add(transcript, 0x140))y := add(y, shl(88, mload(add(transcript, 0x160))))y := add(y, shl(176, mload(add(transcript, 0x180))))mstore(add(transcript, 0x1480), y)            success := and(validate_ec_point(x, y), success)        }
mstore(add(transcript, 0x14a0), mulmod(mload(add(transcript, 0xfe0)), mload(add(transcript, 0xfe0)), f_q))
mstore(add(transcript, 0x14c0), mulmod(mload(add(transcript, 0x14a0)), mload(add(transcript, 0x14a0)), f_q))
mstore(add(transcript, 0x14e0), mulmod(mload(add(transcript, 0x14c0)), mload(add(transcript, 0x14c0)), f_q))
mstore(add(transcript, 0x1500), mulmod(mload(add(transcript, 0x14e0)), mload(add(transcript, 0x14e0)), f_q))
mstore(add(transcript, 0x1520), mulmod(mload(add(transcript, 0x1500)), mload(add(transcript, 0x1500)), f_q))
mstore(add(transcript, 0x1540), mulmod(mload(add(transcript, 0x1520)), mload(add(transcript, 0x1520)), f_q))
mstore(add(transcript, 0x1560), mulmod(mload(add(transcript, 0x1540)), mload(add(transcript, 0x1540)), f_q))
mstore(add(transcript, 0x1580), mulmod(mload(add(transcript, 0x1560)), mload(add(transcript, 0x1560)), f_q))
mstore(add(transcript, 0x15a0), mulmod(mload(add(transcript, 0x1580)), mload(add(transcript, 0x1580)), f_q))
mstore(add(transcript, 0x15c0), mulmod(mload(add(transcript, 0x15a0)), mload(add(transcript, 0x15a0)), f_q))
mstore(add(transcript, 0x15e0), mulmod(mload(add(transcript, 0x15c0)), mload(add(transcript, 0x15c0)), f_q))
mstore(add(transcript, 0x1600), mulmod(mload(add(transcript, 0x15e0)), mload(add(transcript, 0x15e0)), f_q))
mstore(add(transcript, 0x1620), mulmod(mload(add(transcript, 0x1600)), mload(add(transcript, 0x1600)), f_q))
mstore(add(transcript, 0x1640), mulmod(mload(add(transcript, 0x1620)), mload(add(transcript, 0x1620)), f_q))
mstore(add(transcript, 0x1660), mulmod(mload(add(transcript, 0x1640)), mload(add(transcript, 0x1640)), f_q))
mstore(add(transcript, 0x1680), mulmod(mload(add(transcript, 0x1660)), mload(add(transcript, 0x1660)), f_q))
mstore(add(transcript, 0x16a0), mulmod(mload(add(transcript, 0x1680)), mload(add(transcript, 0x1680)), f_q))
mstore(add(transcript, 0x16c0), mulmod(mload(add(transcript, 0x16a0)), mload(add(transcript, 0x16a0)), f_q))
mstore(add(transcript, 0x16e0), mulmod(mload(add(transcript, 0x16c0)), mload(add(transcript, 0x16c0)), f_q))
mstore(add(transcript, 0x1700), mulmod(mload(add(transcript, 0x16e0)), mload(add(transcript, 0x16e0)), f_q))
mstore(add(transcript, 0x1720), mulmod(mload(add(transcript, 0x1700)), mload(add(transcript, 0x1700)), f_q))
mstore(add(transcript, 0x1740), mulmod(mload(add(transcript, 0x1720)), mload(add(transcript, 0x1720)), f_q))
mstore(add(transcript, 0x1760), mulmod(mload(add(transcript, 0x1740)), mload(add(transcript, 0x1740)), f_q))
mstore(add(transcript, 0x1780), mulmod(mload(add(transcript, 0x1760)), mload(add(transcript, 0x1760)), f_q))
mstore(add(transcript, 0x17a0), addmod(mload(add(transcript, 0x1780)), 21888242871839275222246405745257275088548364400416034343698204186575808495616, f_q))
mstore(add(transcript, 0x17c0), mulmod(mload(add(transcript, 0x17a0)), 21888241567198334088790460357988866238279339518792980768180410072331574733841, f_q))
mstore(add(transcript, 0x17e0), mulmod(mload(add(transcript, 0x17c0)), 12929131318670223636853686797196826072950305380535537217467769528748593133487, f_q))
mstore(add(transcript, 0x1800), addmod(mload(add(transcript, 0xfe0)), 8959111553169051585392718948060449015598059019880497126230434657827215362130, f_q))
mstore(add(transcript, 0x1820), mulmod(mload(add(transcript, 0x17c0)), 14655294445420895451632927078981340937842238432098198055057679026789553137428, f_q))
mstore(add(transcript, 0x1840), addmod(mload(add(transcript, 0xfe0)), 7232948426418379770613478666275934150706125968317836288640525159786255358189, f_q))
mstore(add(transcript, 0x1860), mulmod(mload(add(transcript, 0x17c0)), 12220484078924208264862893648548198807365556694478604924193442790112568454894, f_q))
mstore(add(transcript, 0x1880), addmod(mload(add(transcript, 0xfe0)), 9667758792915066957383512096709076281182807705937429419504761396463240040723, f_q))
mstore(add(transcript, 0x18a0), mulmod(mload(add(transcript, 0x17c0)), 8734126352828345679573237859165904705806588461301144420590422589042130041188, f_q))
mstore(add(transcript, 0x18c0), addmod(mload(add(transcript, 0xfe0)), 13154116519010929542673167886091370382741775939114889923107781597533678454429, f_q))
mstore(add(transcript, 0x18e0), mulmod(mload(add(transcript, 0x17c0)), 7358966525675286471217089135633860168646304224547606326237275077574224349359, f_q))
mstore(add(transcript, 0x1900), addmod(mload(add(transcript, 0xfe0)), 14529276346163988751029316609623414919902060175868428017460929109001584146258, f_q))
mstore(add(transcript, 0x1920), mulmod(mload(add(transcript, 0x17c0)), 9741553891420464328295280489650144566903017206473301385034033384879943874347, f_q))
mstore(add(transcript, 0x1940), addmod(mload(add(transcript, 0xfe0)), 12146688980418810893951125255607130521645347193942732958664170801695864621270, f_q))
mstore(add(transcript, 0x1960), mulmod(mload(add(transcript, 0x17c0)), 17329448237240114492580865744088056414251735686965494637158808787419781175510, f_q))
mstore(add(transcript, 0x1980), addmod(mload(add(transcript, 0xfe0)), 4558794634599160729665540001169218674296628713450539706539395399156027320107, f_q))
mstore(add(transcript, 0x19a0), mulmod(mload(add(transcript, 0x17c0)), 1, f_q))
mstore(add(transcript, 0x19c0), addmod(mload(add(transcript, 0xfe0)), 21888242871839275222246405745257275088548364400416034343698204186575808495616, f_q))
mstore(add(transcript, 0x19e0), mulmod(mload(add(transcript, 0x17c0)), 11451405578697956743456240853980216273390554734748796433026540431386972584651, f_q))
mstore(add(transcript, 0x1a00), addmod(mload(add(transcript, 0xfe0)), 10436837293141318478790164891277058815157809665667237910671663755188835910966, f_q))
mstore(add(transcript, 0x1a20), mulmod(mload(add(transcript, 0x17c0)), 8374374965308410102411073611984011876711565317741801500439755773472076597347, f_q))
mstore(add(transcript, 0x1a40), addmod(mload(add(transcript, 0xfe0)), 13513867906530865119835332133273263211836799082674232843258448413103731898270, f_q))
mstore(add(transcript, 0x1a60), mulmod(mload(add(transcript, 0x17c0)), 21490807004895109926141140246143262403290679459142140821740925192625185504522, f_q))
mstore(add(transcript, 0x1a80), addmod(mload(add(transcript, 0xfe0)), 397435866944165296105265499114012685257684941273893521957278993950622991095, f_q))
mstore(add(transcript, 0x1aa0), mulmod(mload(add(transcript, 0x17c0)), 11211301017135681023579411905410872569206244553457844956874280139879520583390, f_q))
mstore(add(transcript, 0x1ac0), addmod(mload(add(transcript, 0xfe0)), 10676941854703594198666993839846402519342119846958189386823924046696287912227, f_q))
mstore(add(transcript, 0x1ae0), mulmod(mload(add(transcript, 0x17c0)), 18846108080730935585192484934247867403156699586319724728525857970312957475341, f_q))
mstore(add(transcript, 0x1b00), addmod(mload(add(transcript, 0xfe0)), 3042134791108339637053920811009407685391664814096309615172346216262851020276, f_q))
mstore(add(transcript, 0x1b20), mulmod(mload(add(transcript, 0x17c0)), 3615478808282855240548287271348143516886772452944084747768312988864436725401, f_q))
mstore(add(transcript, 0x1b40), addmod(mload(add(transcript, 0xfe0)), 18272764063556419981698118473909131571661591947471949595929891197711371770216, f_q))
mstore(add(transcript, 0x1b60), mulmod(mload(add(transcript, 0x17c0)), 21451937155080765789602997556105366785934335730087568134349216848800867145453, f_q))
mstore(add(transcript, 0x1b80), addmod(mload(add(transcript, 0xfe0)), 436305716758509432643408189151908302614028670328466209348987337774941350164, f_q))
mstore(add(transcript, 0x1ba0), mulmod(mload(add(transcript, 0x17c0)), 1426404432721484388505361748317961535523355871255605456897797744433766488507, f_q))
mstore(add(transcript, 0x1bc0), addmod(mload(add(transcript, 0xfe0)), 20461838439117790833741043996939313553025008529160428886800406442142042007110, f_q))
mstore(add(transcript, 0x1be0), mulmod(mload(add(transcript, 0x17c0)), 13982290267294411190096162596630216412723378687553046594730793425118513274800, f_q))
mstore(add(transcript, 0x1c00), addmod(mload(add(transcript, 0xfe0)), 7905952604544864032150243148627058675824985712862987748967410761457295220817, f_q))
mstore(add(transcript, 0x1c20), mulmod(mload(add(transcript, 0x17c0)), 216092043779272773661818549620449970334216366264741118684015851799902419467, f_q))
mstore(add(transcript, 0x1c40), addmod(mload(add(transcript, 0xfe0)), 21672150828060002448584587195636825118214148034151293225014188334775906076150, f_q))
mstore(add(transcript, 0x1c60), mulmod(mload(add(transcript, 0x17c0)), 9537783784440837896026284659246718978615447564543116209283382057778110278482, f_q))
mstore(add(transcript, 0x1c80), addmod(mload(add(transcript, 0xfe0)), 12350459087398437326220121086010556109932916835872918134414822128797698217135, f_q))
mstore(add(transcript, 0x1ca0), mulmod(mload(add(transcript, 0x17c0)), 12619617507853212586156872920672483948819476989779550311307282715684870266992, f_q))
mstore(add(transcript, 0x1cc0), addmod(mload(add(transcript, 0xfe0)), 9268625363986062636089532824584791139728887410636484032390921470890938228625, f_q))
mstore(add(transcript, 0x1ce0), mulmod(mload(add(transcript, 0x17c0)), 3947443723575973965644279767310964219908423994086470065513888332899718123222, f_q))
mstore(add(transcript, 0x1d00), addmod(mload(add(transcript, 0xfe0)), 17940799148263301256602125977946310868639940406329564278184315853676090372395, f_q))
mstore(add(transcript, 0x1d20), mulmod(mload(add(transcript, 0x17c0)), 18610195890048912503953886742825279624920778288956610528523679659246523534888, f_q))
mstore(add(transcript, 0x1d40), addmod(mload(add(transcript, 0xfe0)), 3278046981790362718292519002431995463627586111459423815174524527329284960729, f_q))
mstore(add(transcript, 0x1d60), mulmod(mload(add(transcript, 0x17c0)), 1539082509056298927655194235755440186888826897239928178265486731666142403222, f_q))
mstore(add(transcript, 0x1d80), addmod(mload(add(transcript, 0xfe0)), 20349160362782976294591211509501834901659537503176106165432717454909666092395, f_q))
mstore(add(transcript, 0x1da0), mulmod(mload(add(transcript, 0x17c0)), 19032961837237948602743626455740240236231119053033140765040043513661803148152, f_q))
mstore(add(transcript, 0x1dc0), addmod(mload(add(transcript, 0xfe0)), 2855281034601326619502779289517034852317245347382893578658160672914005347465, f_q))
mstore(add(transcript, 0x1de0), mulmod(mload(add(transcript, 0x17c0)), 4317410353320599552056040796202302907960891408523818766419977508859423800635, f_q))
mstore(add(transcript, 0x1e00), addmod(mload(add(transcript, 0xfe0)), 17570832518518675670190364949054972180587472991892215577278226677716384694982, f_q))
mstore(add(transcript, 0x1e20), mulmod(mload(add(transcript, 0x17c0)), 14875928112196239563830800280253496262679717528621719058794366823499719730250, f_q))
mstore(add(transcript, 0x1e40), addmod(mload(add(transcript, 0xfe0)), 7012314759643035658415605465003778825868646871794315284903837363076088765367, f_q))
mstore(add(transcript, 0x1e60), mulmod(mload(add(transcript, 0x17c0)), 2366023502186770334390939928726871658997402416352868340984630739442624219298, f_q))
mstore(add(transcript, 0x1e80), addmod(mload(add(transcript, 0xfe0)), 19522219369652504887855465816530403429550961984063166002713573447133184276319, f_q))
mstore(add(transcript, 0x1ea0), mulmod(mload(add(transcript, 0x17c0)), 915149353520972163646494413843788069594022902357002628455555785223409501882, f_q))
mstore(add(transcript, 0x1ec0), addmod(mload(add(transcript, 0xfe0)), 20973093518318303058599911331413487018954341498059031715242648401352398993735, f_q))
mstore(add(transcript, 0x1ee0), mulmod(mload(add(transcript, 0x17c0)), 14391499717548074167711220639833994904150450341569029103202493919171555826079, f_q))
mstore(add(transcript, 0x1f00), addmod(mload(add(transcript, 0xfe0)), 7496743154291201054535185105423280184397914058847005240495710267404252669538, f_q))
mstore(add(transcript, 0x1f20), mulmod(mload(add(transcript, 0x17c0)), 5522161504810533295870699551020523636289972223872138525048055197429246400245, f_q))
mstore(add(transcript, 0x1f40), addmod(mload(add(transcript, 0xfe0)), 16366081367028741926375706194236751452258392176543895818650148989146562095372, f_q))
mstore(add(transcript, 0x1f60), mulmod(mload(add(transcript, 0x17c0)), 10119780362642123194334092174270235809557798114544683654677907882314807212354, f_q))
mstore(add(transcript, 0x1f80), addmod(mload(add(transcript, 0xfe0)), 11768462509197152027912313570987039278990566285871350689020296304261001283263, f_q))
mstore(add(transcript, 0x1fa0), mulmod(mload(add(transcript, 0x17c0)), 3766081621734395783232337525162072736827576297943013392955872170138036189193, f_q))
mstore(add(transcript, 0x1fc0), addmod(mload(add(transcript, 0xfe0)), 18122161250104879439014068220095202351720788102473020950742332016437772306424, f_q))
mstore(add(transcript, 0x1fe0), mulmod(mload(add(transcript, 0x17c0)), 2080322550956715654503104356805349981348621877591103674778333538652571537127, f_q))
mstore(add(transcript, 0x2000), addmod(mload(add(transcript, 0xfe0)), 19807920320882559567743301388451925107199742522824930668919870647923236958490, f_q))
mstore(add(transcript, 0x2020), mulmod(mload(add(transcript, 0x17c0)), 9100833993744738801214480881117348002768153232283708533639316963648253510584, f_q))
mstore(add(transcript, 0x2040), addmod(mload(add(transcript, 0xfe0)), 12787408878094536421031924864139927085780211168132325810058887222927554985033, f_q))
mstore(add(transcript, 0x2060), mulmod(mload(add(transcript, 0x17c0)), 11145214675344139457514777444556774698911688619991656085001542609383151586084, f_q))
mstore(add(transcript, 0x2080), addmod(mload(add(transcript, 0xfe0)), 10743028196495135764731628300700500389636675780424378258696661577192656909533, f_q))
mstore(add(transcript, 0x20a0), mulmod(mload(add(transcript, 0x17c0)), 4245441013247250116003069945606352967193023389718465410501109428393342802981, f_q))
mstore(add(transcript, 0x20c0), addmod(mload(add(transcript, 0xfe0)), 17642801858592025106243335799650922121355341010697568933197094758182465692636, f_q))
mstore(add(transcript, 0x20e0), mulmod(mload(add(transcript, 0x17c0)), 19228510170961893342195489288913594506775385223367826565223897736323409650249, f_q))
mstore(add(transcript, 0x2100), addmod(mload(add(transcript, 0xfe0)), 2659732700877381880050916456343680581772979177048207778474306450252398845368, f_q))
mstore(add(transcript, 0x2120), mulmod(mload(add(transcript, 0x17c0)), 6132660129994545119218258312491950835441607143741804980633129304664017206141, f_q))
mstore(add(transcript, 0x2140), addmod(mload(add(transcript, 0xfe0)), 15755582741844730103028147432765324253106757256674229363065074881911791289476, f_q))
mstore(add(transcript, 0x2160), mulmod(mload(add(transcript, 0x17c0)), 10094752117139066216691253588991632982053223883646966177987813353508871280747, f_q))
mstore(add(transcript, 0x2180), addmod(mload(add(transcript, 0xfe0)), 11793490754700209005555152156265642106495140516769068165710390833066937214870, f_q))
mstore(add(transcript, 0x21a0), mulmod(mload(add(transcript, 0x17c0)), 5854133144571823792863860130267644613802765696134002830362054821530146160770, f_q))
mstore(add(transcript, 0x21c0), addmod(mload(add(transcript, 0xfe0)), 16034109727267451429382545614989630474745598704282031513336149365045662334847, f_q))
mstore(add(transcript, 0x21e0), mulmod(mload(add(transcript, 0x17c0)), 21346203717540287263608402129024479709126363130664317843105498655869866203005, f_q))
mstore(add(transcript, 0x2200), addmod(mload(add(transcript, 0xfe0)), 542039154298987958638003616232795379422001269751716500592705530705942292612, f_q))
mstore(add(transcript, 0x2220), mulmod(mload(add(transcript, 0x17c0)), 515148244606945972463850631189471072103916690263705052318085725998468254533, f_q))
mstore(add(transcript, 0x2240), addmod(mload(add(transcript, 0xfe0)), 21373094627232329249782555114067804016444447710152329291380118460577340241084, f_q))
mstore(add(transcript, 0x2260), mulmod(mload(add(transcript, 0x17c0)), 13788243025932779125104144225768424453664118806559109014238064020826883170336, f_q))
mstore(add(transcript, 0x2280), addmod(mload(add(transcript, 0xfe0)), 8099999845906496097142261519488850634884245593856925329460140165748925325281, f_q))
mstore(add(transcript, 0x22a0), mulmod(mload(add(transcript, 0x17c0)), 5980488956150442207659150513163747165544364597008566989111579977672498964212, f_q))
mstore(add(transcript, 0x22c0), addmod(mload(add(transcript, 0xfe0)), 15907753915688833014587255232093527923003999803407467354586624208903309531405, f_q))
mstore(add(transcript, 0x22e0), mulmod(mload(add(transcript, 0x17c0)), 8561696234966975469289029207282849740510759316794581475824569334969644143582, f_q))
mstore(add(transcript, 0x2300), addmod(mload(add(transcript, 0xfe0)), 13326546636872299752957376537974425348037605083621452867873634851606164352035, f_q))
mstore(add(transcript, 0x2320), mulmod(mload(add(transcript, 0x17c0)), 5223738580615264174925218065001555728265216895679471490312087802465486318994, f_q))
mstore(add(transcript, 0x2340), addmod(mload(add(transcript, 0xfe0)), 16664504291224011047321187680255719360283147504736562853386116384110322176623, f_q))
mstore(add(transcript, 0x2360), mulmod(mload(add(transcript, 0x17c0)), 3302268277365219249160464068848832456250192077357408622723420445620736662125, f_q))
mstore(add(transcript, 0x2380), addmod(mload(add(transcript, 0xfe0)), 18585974594474055973085941676408442632298172323058625720974783740955071833492, f_q))
mstore(add(transcript, 0x23a0), mulmod(mload(add(transcript, 0x17c0)), 14557038802599140430182096396825290815503940951075961210638273254419942783582, f_q))
mstore(add(transcript, 0x23c0), addmod(mload(add(transcript, 0xfe0)), 7331204069240134792064309348431984273044423449340073133059930932155865712035, f_q))
mstore(add(transcript, 0x23e0), mulmod(mload(add(transcript, 0x17c0)), 21631349642691366221117117325940229443266870213711402446456178962469345982255, f_q))
mstore(add(transcript, 0x2400), addmod(mload(add(transcript, 0xfe0)), 256893229147909001129288419317045645281494186704631897242025224106462513362, f_q))
mstore(add(transcript, 0x2420), mulmod(mload(add(transcript, 0x17c0)), 16976236069879939850923145256911338076234942200101755618884183331004076579046, f_q))
mstore(add(transcript, 0x2440), addmod(mload(add(transcript, 0xfe0)), 4912006801959335371323260488345937012313422200314278724814020855571731916571, f_q))
mstore(add(transcript, 0x2460), mulmod(mload(add(transcript, 0x17c0)), 18106030913818996184930975996483865250387924434749113154514488995517615180373, f_q))
mstore(add(transcript, 0x2480), addmod(mload(add(transcript, 0xfe0)), 3782211958020279037315429748773409838160439965666921189183715191058193315244, f_q))
mstore(add(transcript, 0x24a0), mulmod(mload(add(transcript, 0x17c0)), 13553911191894110065493137367144919847521088405945523452288398666974237857208, f_q))
mstore(add(transcript, 0x24c0), addmod(mload(add(transcript, 0xfe0)), 8334331679945165156753268378112355241027275994470510891409805519601570638409, f_q))
mstore(add(transcript, 0x24e0), mulmod(mload(add(transcript, 0x17c0)), 15126807493918544618788554261654793824894621953586710625413511093368555507114, f_q))
mstore(add(transcript, 0x2500), addmod(mload(add(transcript, 0xfe0)), 6761435377920730603457851483602481263653742446829323718284693093207252988503, f_q))
mstore(add(transcript, 0x2520), mulmod(mload(add(transcript, 0x17c0)), 12222687719926148270818604386979005738180875192307070468454582955273533101023, f_q))
mstore(add(transcript, 0x2540), addmod(mload(add(transcript, 0xfe0)), 9665555151913126951427801358278269350367489208108963875243621231302275394594, f_q))
mstore(add(transcript, 0x2560), mulmod(mload(add(transcript, 0x17c0)), 16714975918200644516413377824646615398811161167186708005951772994925725210988, f_q))
mstore(add(transcript, 0x2580), addmod(mload(add(transcript, 0xfe0)), 5173266953638630705833027920610659689737203233229326337746431191650083284629, f_q))
mstore(add(transcript, 0x25a0), mulmod(mload(add(transcript, 0x17c0)), 9697063347556872083384215826199993067635178715531258559890418744774301211662, f_q))
mstore(add(transcript, 0x25c0), addmod(mload(add(transcript, 0xfe0)), 12191179524282403138862189919057282020913185684884775783807785441801507283955, f_q))
mstore(add(transcript, 0x25e0), mulmod(mload(add(transcript, 0x17c0)), 8232431451150482057473812611943294635402895089782291356256081195754688638419, f_q))
mstore(add(transcript, 0x2600), addmod(mload(add(transcript, 0xfe0)), 13655811420688793164772593133313980453145469310633742987442122990821119857198, f_q))
mstore(add(transcript, 0x2620), mulmod(mload(add(transcript, 0x17c0)), 13783318220968413117070077848579881425001701814458176881760898225529300547844, f_q))
mstore(add(transcript, 0x2640), addmod(mload(add(transcript, 0xfe0)), 8104924650870862105176327896677393663546662585957857461937305961046507947773, f_q))
mstore(add(transcript, 0x2660), mulmod(mload(add(transcript, 0x17c0)), 17070294809977715215077308683367050851120007385961664319144486981376266100228, f_q))
mstore(add(transcript, 0x2680), addmod(mload(add(transcript, 0xfe0)), 4817948061861560007169097061890224237428357014454370024553717205199542395389, f_q))
mstore(add(transcript, 0x26a0), mulmod(mload(add(transcript, 0x17c0)), 10807735674816066981985242612061336605021639643453679977988966079770672437131, f_q))
mstore(add(transcript, 0x26c0), addmod(mload(add(transcript, 0xfe0)), 11080507197023208240261163133195938483526724756962354365709238106805136058486, f_q))
mstore(add(transcript, 0x26e0), mulmod(mload(add(transcript, 0x17c0)), 10320222094738691136760616041626757686650252828592064883134944032883139493239, f_q))
mstore(add(transcript, 0x2700), addmod(mload(add(transcript, 0xfe0)), 11568020777100584085485789703630517401898111571823969460563260153692669002378, f_q))
mstore(add(transcript, 0x2720), mulmod(mload(add(transcript, 0x17c0)), 15487660954688013862248478071816391715224351867581977083810729441220383572585, f_q))
mstore(add(transcript, 0x2740), addmod(mload(add(transcript, 0xfe0)), 6400581917151261359997927673440883373324012532834057259887474745355424923032, f_q))
mstore(add(transcript, 0x2760), mulmod(mload(add(transcript, 0x17c0)), 12896114329936223826328336851156210236116218608332234285980274197209453560736, f_q))
mstore(add(transcript, 0x2780), addmod(mload(add(transcript, 0xfe0)), 8992128541903051395918068894101064852432145792083800057717929989366354934881, f_q))
mstore(add(transcript, 0x27a0), mulmod(mload(add(transcript, 0x17c0)), 12459868075641381822485233712013080087763946065665469821362892189399541605692, f_q))
mstore(add(transcript, 0x27c0), addmod(mload(add(transcript, 0xfe0)), 9428374796197893399761172033244195000784418334750564522335311997176266889925, f_q))
mstore(add(transcript, 0x27e0), mulmod(mload(add(transcript, 0x17c0)), 19920191427190722095796166662590871096930011470879410060483116711019686308362, f_q))
mstore(add(transcript, 0x2800), addmod(mload(add(transcript, 0xfe0)), 1968051444648553126450239082666403991618352929536624283215087475556122187255, f_q))
mstore(add(transcript, 0x2820), mulmod(mload(add(transcript, 0x17c0)), 12562571400845953139885120066983392294851269266041089223701347829190217414825, f_q))
mstore(add(transcript, 0x2840), addmod(mload(add(transcript, 0xfe0)), 9325671470993322082361285678273882793697095134374945119996856357385591080792, f_q))
mstore(add(transcript, 0x2860), mulmod(mload(add(transcript, 0x17c0)), 14448452208700780299613904085074562738832656926008536161675287466267527586412, f_q))
mstore(add(transcript, 0x2880), addmod(mload(add(transcript, 0xfe0)), 7439790663138494922632501660182712349715707474407498182022916720308280909205, f_q))
mstore(add(transcript, 0x28a0), mulmod(mload(add(transcript, 0x17c0)), 16038300751658239075779628684257016433412502747804121525056508685985277092575, f_q))
mstore(add(transcript, 0x28c0), addmod(mload(add(transcript, 0xfe0)), 5849942120181036146466777061000258655135861652611912818641695500590531403042, f_q))
mstore(add(transcript, 0x28e0), mulmod(mload(add(transcript, 0x17c0)), 14084705004012911259675385222203814438408503240448202630833832765018917772160, f_q))
mstore(add(transcript, 0x2900), addmod(mload(add(transcript, 0xfe0)), 7803537867826363962571020523053460650139861159967831712864371421556890723457, f_q))
mstore(add(transcript, 0x2920), mulmod(mload(add(transcript, 0x17c0)), 17665522928519859765452767154433594409738037332395989540221744312194874941704, f_q))
mstore(add(transcript, 0x2940), addmod(mload(add(transcript, 0xfe0)), 4222719943319415456793638590823680678810327068020044803476459874380933553913, f_q))
mstore(add(transcript, 0x2960), mulmod(mload(add(transcript, 0x17c0)), 16295049735753754081616348893169020553309720529814216200499589072340851153544, f_q))
mstore(add(transcript, 0x2980), addmod(mload(add(transcript, 0xfe0)), 5593193136085521140630056852088254535238643870601818143198615114234957342073, f_q))
mstore(add(transcript, 0x29a0), mulmod(mload(add(transcript, 0x17c0)), 6955697244493336113861667751840378876927906302623587437721024018233754910398, f_q))
mstore(add(transcript, 0x29c0), addmod(mload(add(transcript, 0xfe0)), 14932545627345939108384737993416896211620458097792446905977180168342053585219, f_q))
mstore(add(transcript, 0x29e0), mulmod(mload(add(transcript, 0x17c0)), 14699031513037352720782022637883087576160364237534146709479748594993796784568, f_q))
mstore(add(transcript, 0x2a00), addmod(mload(add(transcript, 0xfe0)), 7189211358801922501464383107374187512388000162881887634218455591582011711049, f_q))
mstore(add(transcript, 0x2a20), mulmod(mload(add(transcript, 0x17c0)), 1918679275621049296283934091410967415474987212511681231948800935495808101054, f_q))
mstore(add(transcript, 0x2a40), addmod(mload(add(transcript, 0xfe0)), 19969563596218225925962471653846307673073377187904353111749403251080000394563, f_q))
mstore(add(transcript, 0x2a60), mulmod(mload(add(transcript, 0x17c0)), 20776965232354160552367722884947240566565796482220309784613818285679578113242, f_q))
mstore(add(transcript, 0x2a80), addmod(mload(add(transcript, 0xfe0)), 1111277639485114669878682860310034521982567918195724559084385900896230382375, f_q))
mstore(add(transcript, 0x2aa0), mulmod(mload(add(transcript, 0x17c0)), 13498745591877810872211159461644682954739332524336278910448604883789771736885, f_q))
mstore(add(transcript, 0x2ac0), addmod(mload(add(transcript, 0xfe0)), 8389497279961464350035246283612592133809031876079755433249599302786036758732, f_q))
mstore(add(transcript, 0x2ae0), mulmod(mload(add(transcript, 0x17c0)), 21158723257009161664752767929965294555629420783981476627372734966438349636085, f_q))
mstore(add(transcript, 0x2b00), addmod(mload(add(transcript, 0xfe0)), 729519614830113557493637815291980532918943616434557716325469220137458859532, f_q))
mstore(add(transcript, 0x2b20), mulmod(mload(add(transcript, 0x17c0)), 6604851689411953560355663038203889299997924520355363678860500374111951937637, f_q))
mstore(add(transcript, 0x2b40), addmod(mload(add(transcript, 0xfe0)), 15283391182427321661890742707053385788550439880060670664837703812463856557980, f_q))
mstore(add(transcript, 0x2b60), mulmod(mload(add(transcript, 0x17c0)), 21702726909732705185590371357192368080626548100357549203145988898368692640320, f_q))
mstore(add(transcript, 0x2b80), addmod(mload(add(transcript, 0xfe0)), 185515962106570036656034388064907007921816300058485140552215288207115855297, f_q))
mstore(add(transcript, 0x2ba0), mulmod(mload(add(transcript, 0x17c0)), 20345677989844117909528750049476969581182118546166966482506114734614108237981, f_q))
mstore(add(transcript, 0x2bc0), addmod(mload(add(transcript, 0xfe0)), 1542564881995157312717655695780305507366245854249067861192089451961700257636, f_q))
mstore(add(transcript, 0x2be0), mulmod(mload(add(transcript, 0x17c0)), 16567582365062587108827662340989684267825804507588024377667462437222984777972, f_q))
mstore(add(transcript, 0x2c00), addmod(mload(add(transcript, 0xfe0)), 5320660506776688113418743404267590820722559892828009966030741749352823717645, f_q))
mstore(add(transcript, 0x2c20), mulmod(mload(add(transcript, 0x17c0)), 11244009323710436498447061620026171700033960328162115124806024297270121927878, f_q))
mstore(add(transcript, 0x2c40), addmod(mload(add(transcript, 0xfe0)), 10644233548128838723799344125231103388514404072253919218892179889305686567739, f_q))
mstore(add(transcript, 0x2c60), mulmod(mload(add(transcript, 0x17c0)), 9706000582800290987287483383922226374157159042727108374973797832689105581010, f_q))
mstore(add(transcript, 0x2c80), addmod(mload(add(transcript, 0xfe0)), 12182242289038984234958922361335048714391205357688925968724406353886702914607, f_q))
mstore(add(transcript, 0x2ca0), mulmod(mload(add(transcript, 0x17c0)), 790608022292213379425324383664216541739009722347092850716054055768832299157, f_q))
mstore(add(transcript, 0x2cc0), addmod(mload(add(transcript, 0xfe0)), 21097634849547061842821081361593058546809354678068941492982150130806976196460, f_q))
mstore(add(transcript, 0x2ce0), mulmod(mload(add(transcript, 0x17c0)), 6863044800505784572032637936646900343567683664237072820316963557403497414578, f_q))
mstore(add(transcript, 0x2d00), addmod(mload(add(transcript, 0xfe0)), 15025198071333490650213767808610374744980680736178961523381240629172311081039, f_q))
mstore(add(transcript, 0x2d20), mulmod(mload(add(transcript, 0x17c0)), 13894403229372218245111098554468346933152618215322268934207074514797092422856, f_q))
mstore(add(transcript, 0x2d40), addmod(mload(add(transcript, 0xfe0)), 7993839642467056977135307190788928155395746185093765409491129671778716072761, f_q))
mstore(add(transcript, 0x2d60), mulmod(mload(add(transcript, 0x17c0)), 14695729834717780593328263844631401143804578596074107977603180578541948031981, f_q))
mstore(add(transcript, 0x2d80), addmod(mload(add(transcript, 0xfe0)), 7192513037121494628918141900625873944743785804341926366095023608033860463636, f_q))
mstore(add(transcript, 0x2da0), mulmod(mload(add(transcript, 0x17c0)), 5289443209903185443361862148540090689648485914368835830972895623576469023722, f_q))
mstore(add(transcript, 0x2dc0), addmod(mload(add(transcript, 0xfe0)), 16598799661936089778884543596717184398899878486047198512725308562999339471895, f_q))
mstore(add(transcript, 0x2de0), mulmod(mload(add(transcript, 0x17c0)), 7576052941218977339273677832719227125500548321635285212418894233844423854719, f_q))
mstore(add(transcript, 0x2e00), addmod(mload(add(transcript, 0xfe0)), 14312189930620297882972727912538047963047816078780749131279309952731384640898, f_q))
mstore(add(transcript, 0x2e20), mulmod(mload(add(transcript, 0x17c0)), 19715528266218439644661892824912275086257866064695767122686506494361332681035, f_q))
mstore(add(transcript, 0x2e40), addmod(mload(add(transcript, 0xfe0)), 2172714605620835577584512920345000002290498335720267221011697692214475814582, f_q))
mstore(add(transcript, 0x2e60), mulmod(mload(add(transcript, 0x17c0)), 17138049032192045255796161309086763455605216692795932871371549627626585504462, f_q))
mstore(add(transcript, 0x2e80), addmod(mload(add(transcript, 0xfe0)), 4750193839647229966450244436170511632943147707620101472326654558949222991155, f_q))
mstore(add(transcript, 0x2ea0), mulmod(mload(add(transcript, 0x17c0)), 15161189183906287273290738379431332336600234154579306802151507052820126345529, f_q))
mstore(add(transcript, 0x2ec0), addmod(mload(add(transcript, 0xfe0)), 6727053687932987948955667365825942751948130245836727541546697133755682150088, f_q))
mstore(add(transcript, 0x2ee0), mulmod(mload(add(transcript, 0x17c0)), 20828296440293398732109704038932725854351740961809584714162618594508586386102, f_q))
mstore(add(transcript, 0x2f00), addmod(mload(add(transcript, 0xfe0)), 1059946431545876490136701706324549234196623438606449629535585592067222109515, f_q))
mstore(add(transcript, 0x2f20), mulmod(mload(add(transcript, 0x17c0)), 12456424076401232823832128238027368612265814450984711658287606686035629293382, f_q))
mstore(add(transcript, 0x2f40), addmod(mload(add(transcript, 0xfe0)), 9431818795438042398414277507229906476282549949431322685410597500540179202235, f_q))
mstore(add(transcript, 0x2f60), mulmod(mload(add(transcript, 0x17c0)), 21197176475461844972521132939065190363981661656829325340754845777811127342944, f_q))
mstore(add(transcript, 0x2f80), addmod(mload(add(transcript, 0xfe0)), 691066396377430249725272806192084724566702743586709002943358408764681152673, f_q))
mstore(add(transcript, 0x2fa0), mulmod(mload(add(transcript, 0x17c0)), 557567375339945239933617516585967620814823575807691402619711360028043331811, f_q))
mstore(add(transcript, 0x2fc0), addmod(mload(add(transcript, 0xfe0)), 21330675496499329982312788228671307467733540824608342941078492826547765163806, f_q))
mstore(add(transcript, 0x2fe0), mulmod(mload(add(transcript, 0x17c0)), 2019472736712337973964917392395976093389166793093559785778261623862133449805, f_q))
mstore(add(transcript, 0x3000), addmod(mload(add(transcript, 0xfe0)), 19868770135126937248281488352861298995159197607322474557919942562713675045812, f_q))
mstore(add(transcript, 0x3020), mulmod(mload(add(transcript, 0x17c0)), 3675353143102618619098608207619541954347747556257261634661810167705798540391, f_q))
mstore(add(transcript, 0x3040), addmod(mload(add(transcript, 0xfe0)), 18212889728736656603147797537637733134200616844158772709036394018870009955226, f_q))
mstore(add(transcript, 0x3060), mulmod(mload(add(transcript, 0x17c0)), 19250430004087471389828686333469487140709165768732581499776246508724938435733, f_q))
mstore(add(transcript, 0x3080), addmod(mload(add(transcript, 0xfe0)), 2637812867751803832417719411787787947839198631683452843921957677850870059884, f_q))
mstore(add(transcript, 0x30a0), mulmod(mload(add(transcript, 0x17c0)), 16611719114775828483319365659907682366622074960672212059891361227499450055959, f_q))
mstore(add(transcript, 0x30c0), addmod(mload(add(transcript, 0xfe0)), 5276523757063446738927040085349592721926289439743822283806842959076358439658, f_q))
{            let prod := mload(add(transcript, 0x1800))                prod := mulmod(mload(add(transcript, 0x1840)), prod, f_q)                mstore(add(transcript, 0x30e0), prod)                            prod := mulmod(mload(add(transcript, 0x1880)), prod, f_q)                mstore(add(transcript, 0x3100), prod)                            prod := mulmod(mload(add(transcript, 0x18c0)), prod, f_q)                mstore(add(transcript, 0x3120), prod)                            prod := mulmod(mload(add(transcript, 0x1900)), prod, f_q)                mstore(add(transcript, 0x3140), prod)                            prod := mulmod(mload(add(transcript, 0x1940)), prod, f_q)                mstore(add(transcript, 0x3160), prod)                            prod := mulmod(mload(add(transcript, 0x1980)), prod, f_q)                mstore(add(transcript, 0x3180), prod)                            prod := mulmod(mload(add(transcript, 0x19c0)), prod, f_q)                mstore(add(transcript, 0x31a0), prod)                            prod := mulmod(mload(add(transcript, 0x1a00)), prod, f_q)                mstore(add(transcript, 0x31c0), prod)                            prod := mulmod(mload(add(transcript, 0x1a40)), prod, f_q)                mstore(add(transcript, 0x31e0), prod)                            prod := mulmod(mload(add(transcript, 0x1a80)), prod, f_q)                mstore(add(transcript, 0x3200), prod)                            prod := mulmod(mload(add(transcript, 0x1ac0)), prod, f_q)                mstore(add(transcript, 0x3220), prod)                            prod := mulmod(mload(add(transcript, 0x1b00)), prod, f_q)                mstore(add(transcript, 0x3240), prod)                            prod := mulmod(mload(add(transcript, 0x1b40)), prod, f_q)                mstore(add(transcript, 0x3260), prod)                            prod := mulmod(mload(add(transcript, 0x1b80)), prod, f_q)                mstore(add(transcript, 0x3280), prod)                            prod := mulmod(mload(add(transcript, 0x1bc0)), prod, f_q)                mstore(add(transcript, 0x32a0), prod)                            prod := mulmod(mload(add(transcript, 0x1c00)), prod, f_q)                mstore(add(transcript, 0x32c0), prod)                            prod := mulmod(mload(add(transcript, 0x1c40)), prod, f_q)                mstore(add(transcript, 0x32e0), prod)                            prod := mulmod(mload(add(transcript, 0x1c80)), prod, f_q)                mstore(add(transcript, 0x3300), prod)                            prod := mulmod(mload(add(transcript, 0x1cc0)), prod, f_q)                mstore(add(transcript, 0x3320), prod)                            prod := mulmod(mload(add(transcript, 0x1d00)), prod, f_q)                mstore(add(transcript, 0x3340), prod)                            prod := mulmod(mload(add(transcript, 0x1d40)), prod, f_q)                mstore(add(transcript, 0x3360), prod)                            prod := mulmod(mload(add(transcript, 0x1d80)), prod, f_q)                mstore(add(transcript, 0x3380), prod)                            prod := mulmod(mload(add(transcript, 0x1dc0)), prod, f_q)                mstore(add(transcript, 0x33a0), prod)                            prod := mulmod(mload(add(transcript, 0x1e00)), prod, f_q)                mstore(add(transcript, 0x33c0), prod)                            prod := mulmod(mload(add(transcript, 0x1e40)), prod, f_q)                mstore(add(transcript, 0x33e0), prod)                            prod := mulmod(mload(add(transcript, 0x1e80)), prod, f_q)                mstore(add(transcript, 0x3400), prod)                            prod := mulmod(mload(add(transcript, 0x1ec0)), prod, f_q)                mstore(add(transcript, 0x3420), prod)                            prod := mulmod(mload(add(transcript, 0x1f00)), prod, f_q)                mstore(add(transcript, 0x3440), prod)                            prod := mulmod(mload(add(transcript, 0x1f40)), prod, f_q)                mstore(add(transcript, 0x3460), prod)                            prod := mulmod(mload(add(transcript, 0x1f80)), prod, f_q)                mstore(add(transcript, 0x3480), prod)                            prod := mulmod(mload(add(transcript, 0x1fc0)), prod, f_q)                mstore(add(transcript, 0x34a0), prod)                            prod := mulmod(mload(add(transcript, 0x2000)), prod, f_q)                mstore(add(transcript, 0x34c0), prod)                            prod := mulmod(mload(add(transcript, 0x2040)), prod, f_q)                mstore(add(transcript, 0x34e0), prod)                            prod := mulmod(mload(add(transcript, 0x2080)), prod, f_q)                mstore(add(transcript, 0x3500), prod)                            prod := mulmod(mload(add(transcript, 0x20c0)), prod, f_q)                mstore(add(transcript, 0x3520), prod)                            prod := mulmod(mload(add(transcript, 0x2100)), prod, f_q)                mstore(add(transcript, 0x3540), prod)                            prod := mulmod(mload(add(transcript, 0x2140)), prod, f_q)                mstore(add(transcript, 0x3560), prod)                            prod := mulmod(mload(add(transcript, 0x2180)), prod, f_q)                mstore(add(transcript, 0x3580), prod)                            prod := mulmod(mload(add(transcript, 0x21c0)), prod, f_q)                mstore(add(transcript, 0x35a0), prod)                            prod := mulmod(mload(add(transcript, 0x2200)), prod, f_q)                mstore(add(transcript, 0x35c0), prod)                            prod := mulmod(mload(add(transcript, 0x2240)), prod, f_q)                mstore(add(transcript, 0x35e0), prod)                            prod := mulmod(mload(add(transcript, 0x2280)), prod, f_q)                mstore(add(transcript, 0x3600), prod)                            prod := mulmod(mload(add(transcript, 0x22c0)), prod, f_q)                mstore(add(transcript, 0x3620), prod)                            prod := mulmod(mload(add(transcript, 0x2300)), prod, f_q)                mstore(add(transcript, 0x3640), prod)                            prod := mulmod(mload(add(transcript, 0x2340)), prod, f_q)                mstore(add(transcript, 0x3660), prod)                            prod := mulmod(mload(add(transcript, 0x2380)), prod, f_q)                mstore(add(transcript, 0x3680), prod)                            prod := mulmod(mload(add(transcript, 0x23c0)), prod, f_q)                mstore(add(transcript, 0x36a0), prod)                            prod := mulmod(mload(add(transcript, 0x2400)), prod, f_q)                mstore(add(transcript, 0x36c0), prod)                            prod := mulmod(mload(add(transcript, 0x2440)), prod, f_q)                mstore(add(transcript, 0x36e0), prod)                            prod := mulmod(mload(add(transcript, 0x2480)), prod, f_q)                mstore(add(transcript, 0x3700), prod)                            prod := mulmod(mload(add(transcript, 0x24c0)), prod, f_q)                mstore(add(transcript, 0x3720), prod)                            prod := mulmod(mload(add(transcript, 0x2500)), prod, f_q)                mstore(add(transcript, 0x3740), prod)                            prod := mulmod(mload(add(transcript, 0x2540)), prod, f_q)                mstore(add(transcript, 0x3760), prod)                            prod := mulmod(mload(add(transcript, 0x2580)), prod, f_q)                mstore(add(transcript, 0x3780), prod)                            prod := mulmod(mload(add(transcript, 0x25c0)), prod, f_q)                mstore(add(transcript, 0x37a0), prod)                            prod := mulmod(mload(add(transcript, 0x2600)), prod, f_q)                mstore(add(transcript, 0x37c0), prod)                            prod := mulmod(mload(add(transcript, 0x2640)), prod, f_q)                mstore(add(transcript, 0x37e0), prod)                            prod := mulmod(mload(add(transcript, 0x2680)), prod, f_q)                mstore(add(transcript, 0x3800), prod)                            prod := mulmod(mload(add(transcript, 0x26c0)), prod, f_q)                mstore(add(transcript, 0x3820), prod)                            prod := mulmod(mload(add(transcript, 0x2700)), prod, f_q)                mstore(add(transcript, 0x3840), prod)                            prod := mulmod(mload(add(transcript, 0x2740)), prod, f_q)                mstore(add(transcript, 0x3860), prod)                            prod := mulmod(mload(add(transcript, 0x2780)), prod, f_q)                mstore(add(transcript, 0x3880), prod)                            prod := mulmod(mload(add(transcript, 0x27c0)), prod, f_q)                mstore(add(transcript, 0x38a0), prod)                            prod := mulmod(mload(add(transcript, 0x2800)), prod, f_q)                mstore(add(transcript, 0x38c0), prod)                            prod := mulmod(mload(add(transcript, 0x2840)), prod, f_q)                mstore(add(transcript, 0x38e0), prod)                            prod := mulmod(mload(add(transcript, 0x2880)), prod, f_q)                mstore(add(transcript, 0x3900), prod)                            prod := mulmod(mload(add(transcript, 0x28c0)), prod, f_q)                mstore(add(transcript, 0x3920), prod)                            prod := mulmod(mload(add(transcript, 0x2900)), prod, f_q)                mstore(add(transcript, 0x3940), prod)                            prod := mulmod(mload(add(transcript, 0x2940)), prod, f_q)                mstore(add(transcript, 0x3960), prod)                            prod := mulmod(mload(add(transcript, 0x2980)), prod, f_q)                mstore(add(transcript, 0x3980), prod)                            prod := mulmod(mload(add(transcript, 0x29c0)), prod, f_q)                mstore(add(transcript, 0x39a0), prod)                            prod := mulmod(mload(add(transcript, 0x2a00)), prod, f_q)                mstore(add(transcript, 0x39c0), prod)                            prod := mulmod(mload(add(transcript, 0x2a40)), prod, f_q)                mstore(add(transcript, 0x39e0), prod)                            prod := mulmod(mload(add(transcript, 0x2a80)), prod, f_q)                mstore(add(transcript, 0x3a00), prod)                            prod := mulmod(mload(add(transcript, 0x2ac0)), prod, f_q)                mstore(add(transcript, 0x3a20), prod)                            prod := mulmod(mload(add(transcript, 0x2b00)), prod, f_q)                mstore(add(transcript, 0x3a40), prod)                            prod := mulmod(mload(add(transcript, 0x2b40)), prod, f_q)                mstore(add(transcript, 0x3a60), prod)                            prod := mulmod(mload(add(transcript, 0x2b80)), prod, f_q)                mstore(add(transcript, 0x3a80), prod)                            prod := mulmod(mload(add(transcript, 0x2bc0)), prod, f_q)                mstore(add(transcript, 0x3aa0), prod)                            prod := mulmod(mload(add(transcript, 0x2c00)), prod, f_q)                mstore(add(transcript, 0x3ac0), prod)                            prod := mulmod(mload(add(transcript, 0x2c40)), prod, f_q)                mstore(add(transcript, 0x3ae0), prod)                            prod := mulmod(mload(add(transcript, 0x2c80)), prod, f_q)                mstore(add(transcript, 0x3b00), prod)                            prod := mulmod(mload(add(transcript, 0x2cc0)), prod, f_q)                mstore(add(transcript, 0x3b20), prod)                            prod := mulmod(mload(add(transcript, 0x2d00)), prod, f_q)                mstore(add(transcript, 0x3b40), prod)                            prod := mulmod(mload(add(transcript, 0x2d40)), prod, f_q)                mstore(add(transcript, 0x3b60), prod)                            prod := mulmod(mload(add(transcript, 0x2d80)), prod, f_q)                mstore(add(transcript, 0x3b80), prod)                            prod := mulmod(mload(add(transcript, 0x2dc0)), prod, f_q)                mstore(add(transcript, 0x3ba0), prod)                            prod := mulmod(mload(add(transcript, 0x2e00)), prod, f_q)                mstore(add(transcript, 0x3bc0), prod)                            prod := mulmod(mload(add(transcript, 0x2e40)), prod, f_q)                mstore(add(transcript, 0x3be0), prod)                            prod := mulmod(mload(add(transcript, 0x2e80)), prod, f_q)                mstore(add(transcript, 0x3c00), prod)                            prod := mulmod(mload(add(transcript, 0x2ec0)), prod, f_q)                mstore(add(transcript, 0x3c20), prod)                            prod := mulmod(mload(add(transcript, 0x2f00)), prod, f_q)                mstore(add(transcript, 0x3c40), prod)                            prod := mulmod(mload(add(transcript, 0x2f40)), prod, f_q)                mstore(add(transcript, 0x3c60), prod)                            prod := mulmod(mload(add(transcript, 0x2f80)), prod, f_q)                mstore(add(transcript, 0x3c80), prod)                            prod := mulmod(mload(add(transcript, 0x2fc0)), prod, f_q)                mstore(add(transcript, 0x3ca0), prod)                            prod := mulmod(mload(add(transcript, 0x3000)), prod, f_q)                mstore(add(transcript, 0x3cc0), prod)                            prod := mulmod(mload(add(transcript, 0x3040)), prod, f_q)                mstore(add(transcript, 0x3ce0), prod)                            prod := mulmod(mload(add(transcript, 0x3080)), prod, f_q)                mstore(add(transcript, 0x3d00), prod)                            prod := mulmod(mload(add(transcript, 0x30c0)), prod, f_q)                mstore(add(transcript, 0x3d20), prod)                            prod := mulmod(mload(add(transcript, 0x17a0)), prod, f_q)                mstore(add(transcript, 0x3d40), prod)                    }
mstore(add(transcript, 0x3d80), 32)
mstore(add(transcript, 0x3da0), 32)
mstore(add(transcript, 0x3dc0), 32)
mstore(add(transcript, 0x3de0), mload(add(transcript, 0x3d40)))
mstore(add(transcript, 0x3e00), 21888242871839275222246405745257275088548364400416034343698204186575808495615)
mstore(add(transcript, 0x3e20), 21888242871839275222246405745257275088548364400416034343698204186575808495617)
success := and(eq(staticcall(gas(), 0x5, add(transcript, 0x3d80), 0xc0, add(transcript, 0x3d60), 0x20), 1), success)
{                        let inv := mload(add(transcript, 0x3d60))            let v                            v := mload(add(transcript, 0x17a0))                    mstore(add(transcript, 0x17a0), mulmod(mload(add(transcript, 0x3d20)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x30c0))                    mstore(add(transcript, 0x30c0), mulmod(mload(add(transcript, 0x3d00)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x3080))                    mstore(add(transcript, 0x3080), mulmod(mload(add(transcript, 0x3ce0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x3040))                    mstore(add(transcript, 0x3040), mulmod(mload(add(transcript, 0x3cc0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x3000))                    mstore(add(transcript, 0x3000), mulmod(mload(add(transcript, 0x3ca0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2fc0))                    mstore(add(transcript, 0x2fc0), mulmod(mload(add(transcript, 0x3c80)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2f80))                    mstore(add(transcript, 0x2f80), mulmod(mload(add(transcript, 0x3c60)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2f40))                    mstore(add(transcript, 0x2f40), mulmod(mload(add(transcript, 0x3c40)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2f00))                    mstore(add(transcript, 0x2f00), mulmod(mload(add(transcript, 0x3c20)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2ec0))                    mstore(add(transcript, 0x2ec0), mulmod(mload(add(transcript, 0x3c00)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2e80))                    mstore(add(transcript, 0x2e80), mulmod(mload(add(transcript, 0x3be0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2e40))                    mstore(add(transcript, 0x2e40), mulmod(mload(add(transcript, 0x3bc0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2e00))                    mstore(add(transcript, 0x2e00), mulmod(mload(add(transcript, 0x3ba0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2dc0))                    mstore(add(transcript, 0x2dc0), mulmod(mload(add(transcript, 0x3b80)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2d80))                    mstore(add(transcript, 0x2d80), mulmod(mload(add(transcript, 0x3b60)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2d40))                    mstore(add(transcript, 0x2d40), mulmod(mload(add(transcript, 0x3b40)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2d00))                    mstore(add(transcript, 0x2d00), mulmod(mload(add(transcript, 0x3b20)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2cc0))                    mstore(add(transcript, 0x2cc0), mulmod(mload(add(transcript, 0x3b00)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2c80))                    mstore(add(transcript, 0x2c80), mulmod(mload(add(transcript, 0x3ae0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2c40))                    mstore(add(transcript, 0x2c40), mulmod(mload(add(transcript, 0x3ac0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2c00))                    mstore(add(transcript, 0x2c00), mulmod(mload(add(transcript, 0x3aa0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2bc0))                    mstore(add(transcript, 0x2bc0), mulmod(mload(add(transcript, 0x3a80)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2b80))                    mstore(add(transcript, 0x2b80), mulmod(mload(add(transcript, 0x3a60)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2b40))                    mstore(add(transcript, 0x2b40), mulmod(mload(add(transcript, 0x3a40)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2b00))                    mstore(add(transcript, 0x2b00), mulmod(mload(add(transcript, 0x3a20)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2ac0))                    mstore(add(transcript, 0x2ac0), mulmod(mload(add(transcript, 0x3a00)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2a80))                    mstore(add(transcript, 0x2a80), mulmod(mload(add(transcript, 0x39e0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2a40))                    mstore(add(transcript, 0x2a40), mulmod(mload(add(transcript, 0x39c0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2a00))                    mstore(add(transcript, 0x2a00), mulmod(mload(add(transcript, 0x39a0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x29c0))                    mstore(add(transcript, 0x29c0), mulmod(mload(add(transcript, 0x3980)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2980))                    mstore(add(transcript, 0x2980), mulmod(mload(add(transcript, 0x3960)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2940))                    mstore(add(transcript, 0x2940), mulmod(mload(add(transcript, 0x3940)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2900))                    mstore(add(transcript, 0x2900), mulmod(mload(add(transcript, 0x3920)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x28c0))                    mstore(add(transcript, 0x28c0), mulmod(mload(add(transcript, 0x3900)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2880))                    mstore(add(transcript, 0x2880), mulmod(mload(add(transcript, 0x38e0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2840))                    mstore(add(transcript, 0x2840), mulmod(mload(add(transcript, 0x38c0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2800))                    mstore(add(transcript, 0x2800), mulmod(mload(add(transcript, 0x38a0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x27c0))                    mstore(add(transcript, 0x27c0), mulmod(mload(add(transcript, 0x3880)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2780))                    mstore(add(transcript, 0x2780), mulmod(mload(add(transcript, 0x3860)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2740))                    mstore(add(transcript, 0x2740), mulmod(mload(add(transcript, 0x3840)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2700))                    mstore(add(transcript, 0x2700), mulmod(mload(add(transcript, 0x3820)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x26c0))                    mstore(add(transcript, 0x26c0), mulmod(mload(add(transcript, 0x3800)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2680))                    mstore(add(transcript, 0x2680), mulmod(mload(add(transcript, 0x37e0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2640))                    mstore(add(transcript, 0x2640), mulmod(mload(add(transcript, 0x37c0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2600))                    mstore(add(transcript, 0x2600), mulmod(mload(add(transcript, 0x37a0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x25c0))                    mstore(add(transcript, 0x25c0), mulmod(mload(add(transcript, 0x3780)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2580))                    mstore(add(transcript, 0x2580), mulmod(mload(add(transcript, 0x3760)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2540))                    mstore(add(transcript, 0x2540), mulmod(mload(add(transcript, 0x3740)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2500))                    mstore(add(transcript, 0x2500), mulmod(mload(add(transcript, 0x3720)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x24c0))                    mstore(add(transcript, 0x24c0), mulmod(mload(add(transcript, 0x3700)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2480))                    mstore(add(transcript, 0x2480), mulmod(mload(add(transcript, 0x36e0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2440))                    mstore(add(transcript, 0x2440), mulmod(mload(add(transcript, 0x36c0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2400))                    mstore(add(transcript, 0x2400), mulmod(mload(add(transcript, 0x36a0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x23c0))                    mstore(add(transcript, 0x23c0), mulmod(mload(add(transcript, 0x3680)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2380))                    mstore(add(transcript, 0x2380), mulmod(mload(add(transcript, 0x3660)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2340))                    mstore(add(transcript, 0x2340), mulmod(mload(add(transcript, 0x3640)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2300))                    mstore(add(transcript, 0x2300), mulmod(mload(add(transcript, 0x3620)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x22c0))                    mstore(add(transcript, 0x22c0), mulmod(mload(add(transcript, 0x3600)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2280))                    mstore(add(transcript, 0x2280), mulmod(mload(add(transcript, 0x35e0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2240))                    mstore(add(transcript, 0x2240), mulmod(mload(add(transcript, 0x35c0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2200))                    mstore(add(transcript, 0x2200), mulmod(mload(add(transcript, 0x35a0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x21c0))                    mstore(add(transcript, 0x21c0), mulmod(mload(add(transcript, 0x3580)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2180))                    mstore(add(transcript, 0x2180), mulmod(mload(add(transcript, 0x3560)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2140))                    mstore(add(transcript, 0x2140), mulmod(mload(add(transcript, 0x3540)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2100))                    mstore(add(transcript, 0x2100), mulmod(mload(add(transcript, 0x3520)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x20c0))                    mstore(add(transcript, 0x20c0), mulmod(mload(add(transcript, 0x3500)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2080))                    mstore(add(transcript, 0x2080), mulmod(mload(add(transcript, 0x34e0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2040))                    mstore(add(transcript, 0x2040), mulmod(mload(add(transcript, 0x34c0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x2000))                    mstore(add(transcript, 0x2000), mulmod(mload(add(transcript, 0x34a0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x1fc0))                    mstore(add(transcript, 0x1fc0), mulmod(mload(add(transcript, 0x3480)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x1f80))                    mstore(add(transcript, 0x1f80), mulmod(mload(add(transcript, 0x3460)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x1f40))                    mstore(add(transcript, 0x1f40), mulmod(mload(add(transcript, 0x3440)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x1f00))                    mstore(add(transcript, 0x1f00), mulmod(mload(add(transcript, 0x3420)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x1ec0))                    mstore(add(transcript, 0x1ec0), mulmod(mload(add(transcript, 0x3400)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x1e80))                    mstore(add(transcript, 0x1e80), mulmod(mload(add(transcript, 0x33e0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x1e40))                    mstore(add(transcript, 0x1e40), mulmod(mload(add(transcript, 0x33c0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x1e00))                    mstore(add(transcript, 0x1e00), mulmod(mload(add(transcript, 0x33a0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x1dc0))                    mstore(add(transcript, 0x1dc0), mulmod(mload(add(transcript, 0x3380)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x1d80))                    mstore(add(transcript, 0x1d80), mulmod(mload(add(transcript, 0x3360)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x1d40))                    mstore(add(transcript, 0x1d40), mulmod(mload(add(transcript, 0x3340)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x1d00))                    mstore(add(transcript, 0x1d00), mulmod(mload(add(transcript, 0x3320)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x1cc0))                    mstore(add(transcript, 0x1cc0), mulmod(mload(add(transcript, 0x3300)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x1c80))                    mstore(add(transcript, 0x1c80), mulmod(mload(add(transcript, 0x32e0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x1c40))                    mstore(add(transcript, 0x1c40), mulmod(mload(add(transcript, 0x32c0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x1c00))                    mstore(add(transcript, 0x1c00), mulmod(mload(add(transcript, 0x32a0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x1bc0))                    mstore(add(transcript, 0x1bc0), mulmod(mload(add(transcript, 0x3280)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x1b80))                    mstore(add(transcript, 0x1b80), mulmod(mload(add(transcript, 0x3260)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x1b40))                    mstore(add(transcript, 0x1b40), mulmod(mload(add(transcript, 0x3240)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x1b00))                    mstore(add(transcript, 0x1b00), mulmod(mload(add(transcript, 0x3220)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x1ac0))                    mstore(add(transcript, 0x1ac0), mulmod(mload(add(transcript, 0x3200)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x1a80))                    mstore(add(transcript, 0x1a80), mulmod(mload(add(transcript, 0x31e0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x1a40))                    mstore(add(transcript, 0x1a40), mulmod(mload(add(transcript, 0x31c0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x1a00))                    mstore(add(transcript, 0x1a00), mulmod(mload(add(transcript, 0x31a0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x19c0))                    mstore(add(transcript, 0x19c0), mulmod(mload(add(transcript, 0x3180)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x1980))                    mstore(add(transcript, 0x1980), mulmod(mload(add(transcript, 0x3160)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x1940))                    mstore(add(transcript, 0x1940), mulmod(mload(add(transcript, 0x3140)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x1900))                    mstore(add(transcript, 0x1900), mulmod(mload(add(transcript, 0x3120)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x18c0))                    mstore(add(transcript, 0x18c0), mulmod(mload(add(transcript, 0x3100)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x1880))                    mstore(add(transcript, 0x1880), mulmod(mload(add(transcript, 0x30e0)), inv, f_q))                    inv := mulmod(v, inv, f_q)                                    v := mload(add(transcript, 0x1840))                    mstore(add(transcript, 0x1840), mulmod(mload(add(transcript, 0x1800)), inv, f_q))                    inv := mulmod(v, inv, f_q)                mstore(add(transcript, 0x1800), inv)        }
mstore(add(transcript, 0x3e40), mulmod(mload(add(transcript, 0x17e0)), mload(add(transcript, 0x1800)), f_q))
mstore(add(transcript, 0x3e60), mulmod(mload(add(transcript, 0x1820)), mload(add(transcript, 0x1840)), f_q))
mstore(add(transcript, 0x3e80), mulmod(mload(add(transcript, 0x1860)), mload(add(transcript, 0x1880)), f_q))
mstore(add(transcript, 0x3ea0), mulmod(mload(add(transcript, 0x18a0)), mload(add(transcript, 0x18c0)), f_q))
mstore(add(transcript, 0x3ec0), mulmod(mload(add(transcript, 0x18e0)), mload(add(transcript, 0x1900)), f_q))
mstore(add(transcript, 0x3ee0), mulmod(mload(add(transcript, 0x1920)), mload(add(transcript, 0x1940)), f_q))
mstore(add(transcript, 0x3f00), mulmod(mload(add(transcript, 0x1960)), mload(add(transcript, 0x1980)), f_q))
mstore(add(transcript, 0x3f20), mulmod(mload(add(transcript, 0x19a0)), mload(add(transcript, 0x19c0)), f_q))
mstore(add(transcript, 0x3f40), mulmod(mload(add(transcript, 0x19e0)), mload(add(transcript, 0x1a00)), f_q))
mstore(add(transcript, 0x3f60), mulmod(mload(add(transcript, 0x1a20)), mload(add(transcript, 0x1a40)), f_q))
mstore(add(transcript, 0x3f80), mulmod(mload(add(transcript, 0x1a60)), mload(add(transcript, 0x1a80)), f_q))
mstore(add(transcript, 0x3fa0), mulmod(mload(add(transcript, 0x1aa0)), mload(add(transcript, 0x1ac0)), f_q))
mstore(add(transcript, 0x3fc0), mulmod(mload(add(transcript, 0x1ae0)), mload(add(transcript, 0x1b00)), f_q))
mstore(add(transcript, 0x3fe0), mulmod(mload(add(transcript, 0x1b20)), mload(add(transcript, 0x1b40)), f_q))
mstore(add(transcript, 0x4000), mulmod(mload(add(transcript, 0x1b60)), mload(add(transcript, 0x1b80)), f_q))
mstore(add(transcript, 0x4020), mulmod(mload(add(transcript, 0x1ba0)), mload(add(transcript, 0x1bc0)), f_q))
mstore(add(transcript, 0x4040), mulmod(mload(add(transcript, 0x1be0)), mload(add(transcript, 0x1c00)), f_q))
mstore(add(transcript, 0x4060), mulmod(mload(add(transcript, 0x1c20)), mload(add(transcript, 0x1c40)), f_q))
mstore(add(transcript, 0x4080), mulmod(mload(add(transcript, 0x1c60)), mload(add(transcript, 0x1c80)), f_q))
mstore(add(transcript, 0x40a0), mulmod(mload(add(transcript, 0x1ca0)), mload(add(transcript, 0x1cc0)), f_q))
mstore(add(transcript, 0x40c0), mulmod(mload(add(transcript, 0x1ce0)), mload(add(transcript, 0x1d00)), f_q))
mstore(add(transcript, 0x40e0), mulmod(mload(add(transcript, 0x1d20)), mload(add(transcript, 0x1d40)), f_q))
mstore(add(transcript, 0x4100), mulmod(mload(add(transcript, 0x1d60)), mload(add(transcript, 0x1d80)), f_q))
mstore(add(transcript, 0x4120), mulmod(mload(add(transcript, 0x1da0)), mload(add(transcript, 0x1dc0)), f_q))
mstore(add(transcript, 0x4140), mulmod(mload(add(transcript, 0x1de0)), mload(add(transcript, 0x1e00)), f_q))
mstore(add(transcript, 0x4160), mulmod(mload(add(transcript, 0x1e20)), mload(add(transcript, 0x1e40)), f_q))
mstore(add(transcript, 0x4180), mulmod(mload(add(transcript, 0x1e60)), mload(add(transcript, 0x1e80)), f_q))
mstore(add(transcript, 0x41a0), mulmod(mload(add(transcript, 0x1ea0)), mload(add(transcript, 0x1ec0)), f_q))
mstore(add(transcript, 0x41c0), mulmod(mload(add(transcript, 0x1ee0)), mload(add(transcript, 0x1f00)), f_q))
mstore(add(transcript, 0x41e0), mulmod(mload(add(transcript, 0x1f20)), mload(add(transcript, 0x1f40)), f_q))
mstore(add(transcript, 0x4200), mulmod(mload(add(transcript, 0x1f60)), mload(add(transcript, 0x1f80)), f_q))
mstore(add(transcript, 0x4220), mulmod(mload(add(transcript, 0x1fa0)), mload(add(transcript, 0x1fc0)), f_q))
mstore(add(transcript, 0x4240), mulmod(mload(add(transcript, 0x1fe0)), mload(add(transcript, 0x2000)), f_q))
mstore(add(transcript, 0x4260), mulmod(mload(add(transcript, 0x2020)), mload(add(transcript, 0x2040)), f_q))
mstore(add(transcript, 0x4280), mulmod(mload(add(transcript, 0x2060)), mload(add(transcript, 0x2080)), f_q))
mstore(add(transcript, 0x42a0), mulmod(mload(add(transcript, 0x20a0)), mload(add(transcript, 0x20c0)), f_q))
mstore(add(transcript, 0x42c0), mulmod(mload(add(transcript, 0x20e0)), mload(add(transcript, 0x2100)), f_q))
mstore(add(transcript, 0x42e0), mulmod(mload(add(transcript, 0x2120)), mload(add(transcript, 0x2140)), f_q))
mstore(add(transcript, 0x4300), mulmod(mload(add(transcript, 0x2160)), mload(add(transcript, 0x2180)), f_q))
mstore(add(transcript, 0x4320), mulmod(mload(add(transcript, 0x21a0)), mload(add(transcript, 0x21c0)), f_q))
mstore(add(transcript, 0x4340), mulmod(mload(add(transcript, 0x21e0)), mload(add(transcript, 0x2200)), f_q))
mstore(add(transcript, 0x4360), mulmod(mload(add(transcript, 0x2220)), mload(add(transcript, 0x2240)), f_q))
mstore(add(transcript, 0x4380), mulmod(mload(add(transcript, 0x2260)), mload(add(transcript, 0x2280)), f_q))
mstore(add(transcript, 0x43a0), mulmod(mload(add(transcript, 0x22a0)), mload(add(transcript, 0x22c0)), f_q))
mstore(add(transcript, 0x43c0), mulmod(mload(add(transcript, 0x22e0)), mload(add(transcript, 0x2300)), f_q))
mstore(add(transcript, 0x43e0), mulmod(mload(add(transcript, 0x2320)), mload(add(transcript, 0x2340)), f_q))
mstore(add(transcript, 0x4400), mulmod(mload(add(transcript, 0x2360)), mload(add(transcript, 0x2380)), f_q))
mstore(add(transcript, 0x4420), mulmod(mload(add(transcript, 0x23a0)), mload(add(transcript, 0x23c0)), f_q))
mstore(add(transcript, 0x4440), mulmod(mload(add(transcript, 0x23e0)), mload(add(transcript, 0x2400)), f_q))
mstore(add(transcript, 0x4460), mulmod(mload(add(transcript, 0x2420)), mload(add(transcript, 0x2440)), f_q))
mstore(add(transcript, 0x4480), mulmod(mload(add(transcript, 0x2460)), mload(add(transcript, 0x2480)), f_q))
mstore(add(transcript, 0x44a0), mulmod(mload(add(transcript, 0x24a0)), mload(add(transcript, 0x24c0)), f_q))
mstore(add(transcript, 0x44c0), mulmod(mload(add(transcript, 0x24e0)), mload(add(transcript, 0x2500)), f_q))
mstore(add(transcript, 0x44e0), mulmod(mload(add(transcript, 0x2520)), mload(add(transcript, 0x2540)), f_q))
mstore(add(transcript, 0x4500), mulmod(mload(add(transcript, 0x2560)), mload(add(transcript, 0x2580)), f_q))
mstore(add(transcript, 0x4520), mulmod(mload(add(transcript, 0x25a0)), mload(add(transcript, 0x25c0)), f_q))
mstore(add(transcript, 0x4540), mulmod(mload(add(transcript, 0x25e0)), mload(add(transcript, 0x2600)), f_q))
mstore(add(transcript, 0x4560), mulmod(mload(add(transcript, 0x2620)), mload(add(transcript, 0x2640)), f_q))
mstore(add(transcript, 0x4580), mulmod(mload(add(transcript, 0x2660)), mload(add(transcript, 0x2680)), f_q))
mstore(add(transcript, 0x45a0), mulmod(mload(add(transcript, 0x26a0)), mload(add(transcript, 0x26c0)), f_q))
mstore(add(transcript, 0x45c0), mulmod(mload(add(transcript, 0x26e0)), mload(add(transcript, 0x2700)), f_q))
mstore(add(transcript, 0x45e0), mulmod(mload(add(transcript, 0x2720)), mload(add(transcript, 0x2740)), f_q))
mstore(add(transcript, 0x4600), mulmod(mload(add(transcript, 0x2760)), mload(add(transcript, 0x2780)), f_q))
mstore(add(transcript, 0x4620), mulmod(mload(add(transcript, 0x27a0)), mload(add(transcript, 0x27c0)), f_q))
mstore(add(transcript, 0x4640), mulmod(mload(add(transcript, 0x27e0)), mload(add(transcript, 0x2800)), f_q))
mstore(add(transcript, 0x4660), mulmod(mload(add(transcript, 0x2820)), mload(add(transcript, 0x2840)), f_q))
mstore(add(transcript, 0x4680), mulmod(mload(add(transcript, 0x2860)), mload(add(transcript, 0x2880)), f_q))
mstore(add(transcript, 0x46a0), mulmod(mload(add(transcript, 0x28a0)), mload(add(transcript, 0x28c0)), f_q))
mstore(add(transcript, 0x46c0), mulmod(mload(add(transcript, 0x28e0)), mload(add(transcript, 0x2900)), f_q))
mstore(add(transcript, 0x46e0), mulmod(mload(add(transcript, 0x2920)), mload(add(transcript, 0x2940)), f_q))
mstore(add(transcript, 0x4700), mulmod(mload(add(transcript, 0x2960)), mload(add(transcript, 0x2980)), f_q))
mstore(add(transcript, 0x4720), mulmod(mload(add(transcript, 0x29a0)), mload(add(transcript, 0x29c0)), f_q))
mstore(add(transcript, 0x4740), mulmod(mload(add(transcript, 0x29e0)), mload(add(transcript, 0x2a00)), f_q))
mstore(add(transcript, 0x4760), mulmod(mload(add(transcript, 0x2a20)), mload(add(transcript, 0x2a40)), f_q))
mstore(add(transcript, 0x4780), mulmod(mload(add(transcript, 0x2a60)), mload(add(transcript, 0x2a80)), f_q))
mstore(add(transcript, 0x47a0), mulmod(mload(add(transcript, 0x2aa0)), mload(add(transcript, 0x2ac0)), f_q))
mstore(add(transcript, 0x47c0), mulmod(mload(add(transcript, 0x2ae0)), mload(add(transcript, 0x2b00)), f_q))
mstore(add(transcript, 0x47e0), mulmod(mload(add(transcript, 0x2b20)), mload(add(transcript, 0x2b40)), f_q))
mstore(add(transcript, 0x4800), mulmod(mload(add(transcript, 0x2b60)), mload(add(transcript, 0x2b80)), f_q))
mstore(add(transcript, 0x4820), mulmod(mload(add(transcript, 0x2ba0)), mload(add(transcript, 0x2bc0)), f_q))
mstore(add(transcript, 0x4840), mulmod(mload(add(transcript, 0x2be0)), mload(add(transcript, 0x2c00)), f_q))
mstore(add(transcript, 0x4860), mulmod(mload(add(transcript, 0x2c20)), mload(add(transcript, 0x2c40)), f_q))
mstore(add(transcript, 0x4880), mulmod(mload(add(transcript, 0x2c60)), mload(add(transcript, 0x2c80)), f_q))
mstore(add(transcript, 0x48a0), mulmod(mload(add(transcript, 0x2ca0)), mload(add(transcript, 0x2cc0)), f_q))
mstore(add(transcript, 0x48c0), mulmod(mload(add(transcript, 0x2ce0)), mload(add(transcript, 0x2d00)), f_q))
mstore(add(transcript, 0x48e0), mulmod(mload(add(transcript, 0x2d20)), mload(add(transcript, 0x2d40)), f_q))
mstore(add(transcript, 0x4900), mulmod(mload(add(transcript, 0x2d60)), mload(add(transcript, 0x2d80)), f_q))
mstore(add(transcript, 0x4920), mulmod(mload(add(transcript, 0x2da0)), mload(add(transcript, 0x2dc0)), f_q))
mstore(add(transcript, 0x4940), mulmod(mload(add(transcript, 0x2de0)), mload(add(transcript, 0x2e00)), f_q))
mstore(add(transcript, 0x4960), mulmod(mload(add(transcript, 0x2e20)), mload(add(transcript, 0x2e40)), f_q))
mstore(add(transcript, 0x4980), mulmod(mload(add(transcript, 0x2e60)), mload(add(transcript, 0x2e80)), f_q))
mstore(add(transcript, 0x49a0), mulmod(mload(add(transcript, 0x2ea0)), mload(add(transcript, 0x2ec0)), f_q))
mstore(add(transcript, 0x49c0), mulmod(mload(add(transcript, 0x2ee0)), mload(add(transcript, 0x2f00)), f_q))
mstore(add(transcript, 0x49e0), mulmod(mload(add(transcript, 0x2f20)), mload(add(transcript, 0x2f40)), f_q))
mstore(add(transcript, 0x4a00), mulmod(mload(add(transcript, 0x2f60)), mload(add(transcript, 0x2f80)), f_q))
mstore(add(transcript, 0x4a20), mulmod(mload(add(transcript, 0x2fa0)), mload(add(transcript, 0x2fc0)), f_q))
mstore(add(transcript, 0x4a40), mulmod(mload(add(transcript, 0x2fe0)), mload(add(transcript, 0x3000)), f_q))
mstore(add(transcript, 0x4a60), mulmod(mload(add(transcript, 0x3020)), mload(add(transcript, 0x3040)), f_q))
mstore(add(transcript, 0x4a80), mulmod(mload(add(transcript, 0x3060)), mload(add(transcript, 0x3080)), f_q))
mstore(add(transcript, 0x4aa0), mulmod(mload(add(transcript, 0x30a0)), mload(add(transcript, 0x30c0)), f_q))

        }}
        return (success, transcript);
    }
}
